package com.sun.xml.internal.ws.client.sei;

import javax.jws.WebParam;
import com.sun.xml.internal.ws.model.ParameterImpl;

abstract class ValueGetterFactory
{
    static final ValueGetterFactory SYNC;
    static final ValueGetterFactory ASYNC;
    
    ValueGetterFactory() {
    }
    
    abstract ValueGetter get(ParameterImpl p0);
    
    static {
        SYNC = new ValueGetterFactory() {
            @Override
            ValueGetter get(ParameterImpl p) {
                return (p.getMode() == WebParam.Mode.IN || p.getIndex() == -1) ? ValueGetter.PLAIN : ValueGetter.HOLDER;
            }
        };
        ASYNC = new ValueGetterFactory() {
            @Override
            ValueGetter get(ParameterImpl p) {
                return ValueGetter.PLAIN;
            }
        };
    }
}
